function s = landmarks(s)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Landmarks matching - to be used with match.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% contact : joan_glaunes@yahoo.fr

method = 'landmarks';

% y (target points) is required
if ~isfield(s,'y')
    error('input structure must contain field <y> (target points)');
end

y = s.y;

% y must be 3D data
if size(y,1)~=3
    error('field <y> must be 3-rows matrix');
end

ny = size(y,2);
if ~isfield(s,'vx')
    vx = 1:ny;
else
    vx = s.vx;
end

matching = @funmatching;
gradmatching = @fungradmatching;

clear s
savestruct('s',who);

vx = 3*vx(:)';
vx = [vx-2;vx-1;vx];
vx = vx(:);

y = y(:);

    function R = funmatching(phix)
        R = sum((phix(vx)-y).^2);
    end

    function g = fungradmatching(phix)    
        g = zeros(size(phix));
        g(vx) = 2*(phix(vx)-y);
    end

end

