function makebyu(V,F,byufile)

% build byu file from vertices and faces data
% usage: makebyu(V,F,byufile)
% V and F must be 3-lines matrices

fbyuout = fopen(byufile,'w');

% header
ncomponents = 1;	                % number of components
fprintf(fbyuout,'%d ',ncomponents);
npoints = size(V,2);	           	% number of vertices
fprintf(fbyuout,'%d ',npoints);
nfaces = size(F,2);         		% number of faces
fprintf(fbyuout,'%d ',nfaces);
nedges = 3*nfaces;          		% number of edges
fprintf(fbyuout,'%d\n',nedges);
fprintf(fbyuout,'%d ',[1 nfaces]);	% components

% write vertices data
fprintf(fbyuout,'\n%f %f %f',V);

% write faces data
F(3,:) = -F(3,:);      % minus sign for byu format
fprintf(fbyuout,'\n%d %d %d',F);

fclose(fbyuout);
